diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/tx-duration-test.cc ns-3.45/src/wifi/test/tx-duration-test.cc
--- ns-3.44/src/wifi/test/tx-duration-test.cc	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/tx-duration-test.cc	2025-06-01 20:34:45.634702200 -0700
@@ -26,6 +26,35 @@
 
 NS_LOG_COMPONENT_DEFINE("TxDurationTest");
 
+namespace
+{
+/**
+ * Create an HE or an EHT RU Specification.
+ * If a primary80 is provided, an HE RU Specification is created, other it is an EHT RU
+ * Specification.
+ *
+ * @param ruType the RU type
+ * @param index the RU index (starting at 1)
+ * @param primaryOrLow80MHz whether the RU is allocated in the primary 80MHz channel or in the low
+ * 80 MHz if the RU is allocated in the secondary 160 MHz
+ * @param primary160MHz whether the RU is allocated in the primary 160MHz channel (only for EHT)
+ * @return the created RU Specification.
+ */
+WifiRu::RuSpec
+MakeRuSpec(RuType ruType,
+           std::size_t index,
+           bool primaryOrLow80MHz,
+           std::optional<bool> primary160MHz = std::nullopt)
+{
+    if (!primary160MHz)
+    {
+        return HeRu::RuSpec{ruType, index, primaryOrLow80MHz};
+    }
+    return EhtRu::RuSpec{ruType, index, *primary160MHz, primaryOrLow80MHz};
+}
+
+} // namespace
+
 /**
  * @ingroup wifi-test
  * @ingroup tests
@@ -41,8 +70,7 @@
 
   private:
     /**
-     * Check if the payload tx duration returned by InterferenceHelper
-     * corresponds to a known value
+     * Check if the payload tx duration returned by the PHY corresponds to a known value
      *
      * @param size size of payload in octets (includes everything after the PHY header)
      * @param payloadMode the WifiMode used for the transmission
@@ -61,8 +89,7 @@
                               Time knownDuration);
 
     /**
-     * Check if the overall tx duration returned by InterferenceHelper
-     * corresponds to a known value
+     * Check if the overall tx duration returned by the PHY corresponds to a known value
      *
      * @param size size of payload in octets (includes everything after the PHY header)
      * @param payloadMode the WifiMode used for the transmission
@@ -142,12 +169,9 @@
     txVector.SetPreambleType(preamble);
     txVector.SetChannelWidth(channelWidth);
     txVector.SetGuardInterval(guardInterval);
-    txVector.SetNss(1);
-    txVector.SetStbc(false);
-    txVector.SetNess(0);
     std::list<WifiPhyBand> testedBands;
     Ptr<YansWifiPhy> phy = CreateObject<YansWifiPhy>();
-    if (payloadMode.GetModulationClass() >= WIFI_MOD_CLASS_OFDM)
+    if ((payloadMode.GetModulationClass() >= WIFI_MOD_CLASS_OFDM) && (channelWidth <= 160))
     {
         testedBands.push_back(WIFI_PHY_BAND_5GHZ);
     }
@@ -155,7 +179,8 @@
     {
         testedBands.push_back(WIFI_PHY_BAND_6GHZ);
     }
-    if (payloadMode.GetModulationClass() != WIFI_MOD_CLASS_VHT)
+    if ((payloadMode.GetModulationClass() != WIFI_MOD_CLASS_OFDM) &&
+        (payloadMode.GetModulationClass() != WIFI_MOD_CLASS_VHT) && (channelWidth < 80))
     {
         testedBands.push_back(WIFI_PHY_BAND_2_4GHZ);
     }
@@ -189,17 +214,14 @@
                                 WifiPreamble preamble,
                                 Time knownDuration)
 {
-    WifiTxVector txVector;
+    WifiTxVector txVector{};
     txVector.SetMode(payloadMode);
     txVector.SetPreambleType(preamble);
     txVector.SetChannelWidth(channelWidth);
     txVector.SetGuardInterval(guardInterval);
-    txVector.SetNss(1);
-    txVector.SetStbc(false);
-    txVector.SetNess(0);
     std::list<WifiPhyBand> testedBands;
     Ptr<YansWifiPhy> phy = CreateObject<YansWifiPhy>();
-    if (payloadMode.GetModulationClass() >= WIFI_MOD_CLASS_OFDM)
+    if ((payloadMode.GetModulationClass() >= WIFI_MOD_CLASS_OFDM) && (channelWidth <= 160))
     {
         testedBands.push_back(WIFI_PHY_BAND_5GHZ);
     }
@@ -207,7 +229,8 @@
     {
         testedBands.push_back(WIFI_PHY_BAND_6GHZ);
     }
-    if (payloadMode.GetModulationClass() != WIFI_MOD_CLASS_VHT)
+    if ((payloadMode.GetModulationClass() != WIFI_MOD_CLASS_OFDM) &&
+        (payloadMode.GetModulationClass() != WIFI_MOD_CLASS_VHT) && (channelWidth < 80))
     {
         testedBands.push_back(WIFI_PHY_BAND_2_4GHZ);
     }
@@ -255,7 +278,7 @@
                            std::end(userInfos),
                            MHz_u{0},
                            [](const MHz_u prevBw, const HeMuUserInfo& info) {
-                               return prevBw + HeRu::GetBandwidth(info.ru.GetRuType());
+                               return prevBw + WifiRu::GetBandwidth(WifiRu::GetRuType(info.ru));
                            }),
         "Cannot accommodate all the RUs in the provided band"); // MU-MIMO (for which allocations
                                                                 // use the same RU) is not supported
@@ -263,8 +286,6 @@
     txVector.SetPreambleType(preamble);
     txVector.SetChannelWidth(channelWidth);
     txVector.SetGuardInterval(guardInterval);
-    txVector.SetStbc(false);
-    txVector.SetNess(0);
     if (IsEht(preamble))
     {
         txVector.SetEhtPpduType(0);
@@ -278,14 +299,21 @@
         staIds.push_back(staId++);
     }
     txVector.SetSigBMode(VhtPhy::GetVhtMcs0());
-    txVector.SetRuAllocation({192, 192}, 0);
+    const uint16_t ruAllocPer20 = IsEht(preamble) ? 64 : 192;
+    txVector.SetRuAllocation({ruAllocPer20, ruAllocPer20}, 0);
 
     Ptr<YansWifiPhy> phy = CreateObject<YansWifiPhy>();
-    std::list<WifiPhyBand> testedBands{
-        WIFI_PHY_BAND_5GHZ,
-        WIFI_PHY_BAND_6GHZ,
-        WIFI_PHY_BAND_2_4GHZ}; // Durations vary depending on frequency; test also 2.4 GHz (bug
-                               // 1971)
+    std::list<WifiPhyBand> testedBands;
+    if (channelWidth <= 160)
+    {
+        testedBands.push_back(WIFI_PHY_BAND_5GHZ);
+    }
+    testedBands.push_back(WIFI_PHY_BAND_6GHZ);
+    if (channelWidth < 80)
+    {
+        // Durations vary depending on frequency; test also 2.4 GHz (bug 1971)
+        testedBands.push_back(WIFI_PHY_BAND_2_4GHZ);
+    }
     for (auto& testedBand : testedBands)
     {
         if (testedBand == WIFI_PHY_BAND_2_4GHZ)
